function valid = check_CV_splits_validity( CV_splits, triplets, n_relationships, n_subjects )

% Tis function makes sure that each training split contains each subject, relationship and object at least once.
%
% Copyright (C) 2012 Rodolphe Jenatton, Nicolas Le Roux, Antoine Bordes, Guillaume Obozinski
%         
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details. 
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


	valid = 1;

	for k=1:length(CV_splits),
		idx = CV_splits{k};

		valid  = valid && numel(unique(triplets(idx, 2))) == n_relationships && numel(unique([triplets(idx, 1); triplets(idx, 3)])) == n_subjects;

		if valid == 0, 
			return;
		end
	end
end
