% This script extends the dataset dnations
%
% Copyright (C) 2012 Rodolphe Jenatton, Nicolas Le Roux, Antoine Bordes, Guillaume Obozinski
%         
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details. 
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%

load dnations

R_ext = zeros(14+111,14+111,56+1);%The original R is of size 14 x 14 x 56

A(isnan(A)) = 0;% we assume that the nan means "no relation"

[idx1, idx2, idx3] = meshgrid(1:14,1:14,1:56);
idx = sub2ind(size(R_ext), idx1(:), idx2(:), idx3(:));

R_ext(idx) = R(:);% we copy the original tensor R in the right location

for country = 1:14,

	present = find(A(country, :));

	n_present = length(present);

	idx = sub2ind(size(R_ext), country*ones(n_present,1), 14+present', 57*ones(n_present,1));

	R_ext(idx) = 1;
%
%	% we impose a reflexivity of the "attribute" relation
	idx = sub2ind(size(R_ext), 14+present', country*ones(n_present,1), 57*ones(n_present,1));

	R_ext(idx) = 1;
end

R = R_ext;

save('dnations_extended.mat', 'A','R','attnames','countrynames','relnnames');
