function projM = L2_proj(M,IsPos)
%
% This function computes the projection onto the unit L2 norm ball, columnwise for M
%
% Copyright (C) 2012 Rodolphe Jenatton, Nicolas Le Roux, Antoine Bordes, Guillaume Obozinski
%         
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details. 
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.




if IsPos,
    projM = max(M,0);
else
    projM = M;
end

norm_M = sqrt(sum(projM.^2, 1));
M_viol = (norm_M > 1);

if any(M_viol),
	projM(:, M_viol) = bsxfun(@times, projM(:, M_viol), 1./norm_M(M_viol));
end
