function [ idx_train, idx_test ] = get_cross_valid_idx( N, KFolds )
%
% Function to generate the splits of the KFolds-cross validation
%
% Copyright (C) 2012 Rodolphe Jenatton, Nicolas Le Roux, Antoine Bordes, Guillaume Obozinski
%         
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details. 
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


if N < KFolds, error('There are not enough samples!'); end

rd_idx = randperm(N);
L      = N/KFolds;

idx       = cell(KFolds,1);
idx_train = cell(KFolds,1);
idx_test  = cell(KFolds,1);

for k=1:KFolds,
    idx{k} = rd_idx( floor((k-1)*L)+1:floor(k*L) );
end

for k=1:KFolds,
    idx_test{k} = idx{k};
    for j=1:(k-1),
        idx_train{k} =  [idx_train{k} idx{j}];
    end
    for j=(k+1):KFolds,
        idx_train{k} =  [idx_train{k} idx{j}];
    end
end

end

