% This script has been taken (and adapted) from the SPAMS toolbox taken developed by Julien Mairal; for details see http://spams-devel.gforge.inria.fr/
clear all;
get_architecture;

compiler='mex';
blas='builtin';

if strcmp(blas,'builtin')
    % leave it to /usr/lib/ for built-in:
    path_to_blas='/';
end
   
debug=false;
if debug 
   use_multithread=false;
end
%%%%%%%%%%%% END OF THE CONFIGURATION %%%%%%%%%%%%%%
% Do not touch what is below this line, unless you know what you are doing
out_dir='./build/';

COMPILE = { 
            % compile functions 
            '-I./linalg/ mexCreateSpGrad.cpp',
            '-I./linalg/ mexInPlace_gradient_update.cpp',  
            '-I./linalg/ mexGetGrad_U_V.cpp',  
            '-I./linalg/ mexGetGrad_alpha.cpp'}; 

%if linux || mac
%   fid=fopen('run_matlab.sh','w+');
%   fprintf(fid,'#!/bin/sh\n');
%end

if sixtyfourbits
   if debug
      DEFCOMMON='-largeArrayDims -DDEBUG';
   else
      DEFCOMMON='-largeArrayDims -DNDEBUG';
   end
else
   if debug
      DEFCOMMON='-DDEBUG';
   else
      DEFCOMMON='-DNDEBUG';
   end
end
if windows
   DEFCOMMON=[DEFCOMMON ' -DWINDOWS -DREMOVE_'];
end

DEFBLAS='';
if strcmp(blas,'builtin')
   blas_link='-lmwblas -lmwlapack';
   DEFBLAS='-DUSE_BLAS_LIB';
end
if ~verLessThan('matlab','7.9.0')
   DEFBLAS=[DEFBLAS ' -DNEW_MATLAB'];
end

links_lib=[blas_link];
link_flags=' -O ';

DEFCOMP='';
compile_flags=' -O';

%if ~windows
%   fprintf(fid,'matlab $* -r \"addpath(''./build/''); addpath(''./test_release''); setenv(''MKL_NUM_THREADS'',''1''); setenv(''MKL_SERIAL'',''YES'');"\n'); 
%   fclose(fid);
%   !chmod +x run_matlab.sh
%end

DEFS=[DEFBLAS ' ' DEFCOMMON ' ' DEFCOMP];

for k = 1:length(COMPILE),
    str = COMPILE{k};
    fprintf('compilation of: %s\n',str);
    if windows
       str = [str ' -outdir ' out_dir, ' ' DEFS ' ' links_lib ' OPTIMFLAGS="' compile_flags '" ']; 
    else
       str = [str ' -outdir ' out_dir, ' ' DEFS ' CXXOPTIMFLAGS="' compile_flags '" LDOPTIMFLAGS="' link_flags '" ' links_lib];
    end
    args = regexp(str, '\s+', 'split');
    args = args(find(~cellfun(@isempty, args)));
    mex(args{:});
end
