//
// Copyright (C) 2012 Rodolphe Jenatton, Nicolas Le Roux, Antoine Bordes, Guillaume Obozinski
//         
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details. 
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#include <mexutils.h>

// Argument 0: A,     whose dim is n x p
//          1: B,     whose dim is n x p (SPARSE) 
//
// compute A + B 
//-------------------------------------------------------------------------

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{
  
  double *A, *B;
  
  mwIndex *B_ir, *B_jc;
  mwIndex j, idx;
  mwIndex n = mxGetM(prhs[0]), p = mxGetN(prhs[0]);

  A = (double*)mxGetPr(prhs[0]);
  B = (double*)mxGetPr(prhs[1]);
 
  B_ir  = (mwIndex*)mxGetIr(prhs[1]);
  B_jc  = (mwIndex*)mxGetJc(prhs[1]);
  //-----------------------------------------------------------------------
  for (j=0;j<p;j++){
      
      for (idx=B_jc[j];idx<B_jc[j+1];idx++)
          
              A[ B_ir[idx] + n*j ] += B[idx];
  }
  
}

